diff --git a/elf/dl-cache.c b/elf/dl-cache.c
index 300aa1b6dd..f9ca40de3f 100644
--- a/elf/dl-cache.c
+++ b/elf/dl-cache.c
@@ -21,7 +21,6 @@
 #include <ldsodefs.h>
 #include <sys/mman.h>
 #include <dl-cache.h>
-#include <dl-procinfo.h>
 #include <stdint.h>
 #include <_itoa.h>
 #include <dl-hwcaps.h>
diff --git a/elf/dl-diagnostics.c b/elf/dl-diagnostics.c
index fb2cfbeeb8..abb644314d 100644
--- a/elf/dl-diagnostics.c
+++ b/elf/dl-diagnostics.c
@@ -24,7 +24,6 @@
 #include <dl-diagnostics.h>
 #include <dl-hwcaps.h>
 #include <dl-main.h>
-#include <dl-procinfo.h>
 #include <dl-sysdep.h>
 #include <ldsodefs.h>
 #include "trusted-dirs.h"
diff --git a/elf/dl-hwcaps.c b/elf/dl-hwcaps.c
index e3d24fba1b..66060d7bb5 100644
--- a/elf/dl-hwcaps.c
+++ b/elf/dl-hwcaps.c
@@ -23,7 +23,6 @@
 #include <unistd.h>
 #include <ldsodefs.h>
 
-#include <dl-procinfo.h>
 #include <dl-hwcaps.h>
 
 /* This is the result of counting the substrings in a colon-separated
diff --git a/elf/dl-support.c b/elf/dl-support.c
index a7d5a5e8ab..c7860f327a 100644
--- a/elf/dl-support.c
+++ b/elf/dl-support.c
@@ -35,7 +35,6 @@
 #include <dl-machine.h>
 #include <libc-lock.h>
 #include <dl-cache.h>
-#include <dl-procinfo.h>
 #include <unsecvars.h>
 #include <hp-timing.h>
 #include <stackinfo.h>
diff --git a/elf/dl-usage.c b/elf/dl-usage.c
index c6d13ac2ee..31b27e5ea6 100644
--- a/elf/dl-usage.c
+++ b/elf/dl-usage.c
@@ -22,7 +22,6 @@
 #include <unistd.h>
 #include "version.h"
 
-#include <dl-procinfo.h>
 #include <dl-hwcaps.h>
 
 void
diff --git a/elf/ldconfig.c b/elf/ldconfig.c
index 1432187e9b..39b154c72c 100644
--- a/elf/ldconfig.c
+++ b/elf/ldconfig.c
@@ -45,7 +45,6 @@
 #include <dl-hwcaps.h>
 #include <dl-is_dso.h>
 
-#include <dl-procinfo.h>
 
 #ifndef LD_SO_CONF
 # define LD_SO_CONF SYSCONFDIR "/ld.so.conf"
diff --git a/elf/rtld.c b/elf/rtld.c
index 115f1da37f..00b25c1a73 100644
--- a/elf/rtld.c
+++ b/elf/rtld.c
@@ -35,7 +35,6 @@
 #include <unsecvars.h>
 #include <dl-cache.h>
 #include <dl-osinfo.h>
-#include <dl-procinfo.h>
 #include <dl-prop.h>
 #include <dl-vdso.h>
 #include <dl-vdso-setup.h>
diff --git a/scripts/gen-tunables.awk b/scripts/gen-tunables.awk
index d9f326b63b..5d34075c16 100644
--- a/scripts/gen-tunables.awk
+++ b/scripts/gen-tunables.awk
@@ -141,7 +141,6 @@ END {
   print "# error \"Do not include this file directly.\""
   print "# error \"Include tunables.h instead.\""
   print "#endif"
-  print "#include <dl-procinfo.h>\n"
 
   # Now, the enum names
   print "\ntypedef enum"
diff --git a/sysdeps/generic/dl-procinfo.h b/sysdeps/generic/dl-procinfo.h
deleted file mode 100644
index 057a4ae362..0000000000
--- a/sysdeps/generic/dl-procinfo.h
+++ /dev/null
@@ -1,25 +0,0 @@
-/* Stub version of processor capability information handling macros.
-   Copyright (C) 1998-2025 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#ifndef _DL_PROCINFO_H
-#define _DL_PROCINFO_H	1
-
-/* We cannot provide a general printing function.  */
-#define _dl_procinfo(type, word) -1
-
-#endif /* dl-procinfo.h */
diff --git a/sysdeps/i386/fpu/fclrexcpt.c b/sysdeps/i386/fpu/fclrexcpt.c
index 2254c49d60..f7a2ed2be1 100644
--- a/sysdeps/i386/fpu/fclrexcpt.c
+++ b/sysdeps/i386/fpu/fclrexcpt.c
@@ -19,7 +19,6 @@
 #include <fenv.h>
 #include <unistd.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 int
 __feclearexcept (int excepts)
diff --git a/sysdeps/i386/fpu/fedisblxcpt.c b/sysdeps/i386/fpu/fedisblxcpt.c
index 305758a267..b23fd8e869 100644
--- a/sysdeps/i386/fpu/fedisblxcpt.c
+++ b/sysdeps/i386/fpu/fedisblxcpt.c
@@ -19,7 +19,6 @@
 #include <fenv.h>
 #include <unistd.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 int
 fedisableexcept (int excepts)
diff --git a/sysdeps/i386/fpu/feenablxcpt.c b/sysdeps/i386/fpu/feenablxcpt.c
index e24d9d5f98..bc4a4ce32f 100644
--- a/sysdeps/i386/fpu/feenablxcpt.c
+++ b/sysdeps/i386/fpu/feenablxcpt.c
@@ -19,7 +19,6 @@
 #include <fenv.h>
 #include <unistd.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 int
 feenableexcept (int excepts)
diff --git a/sysdeps/i386/fpu/fegetenv.c b/sysdeps/i386/fpu/fegetenv.c
index 3c58ea6ef1..0d2b87db93 100644
--- a/sysdeps/i386/fpu/fegetenv.c
+++ b/sysdeps/i386/fpu/fegetenv.c
@@ -19,7 +19,6 @@
 #include <fenv.h>
 #include <unistd.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 int
 __fegetenv (fenv_t *envp)
diff --git a/sysdeps/i386/fpu/fegetmode.c b/sysdeps/i386/fpu/fegetmode.c
index ff3f98834f..41275e1036 100644
--- a/sysdeps/i386/fpu/fegetmode.c
+++ b/sysdeps/i386/fpu/fegetmode.c
@@ -20,7 +20,6 @@
 #include <fpu_control.h>
 #include <unistd.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 int
 fegetmode (femode_t *modep)
diff --git a/sysdeps/i386/fpu/feholdexcpt.c b/sysdeps/i386/fpu/feholdexcpt.c
index 3b689b97c9..a323a04f27 100644
--- a/sysdeps/i386/fpu/feholdexcpt.c
+++ b/sysdeps/i386/fpu/feholdexcpt.c
@@ -19,7 +19,6 @@
 #include <fenv.h>
 #include <unistd.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 int
 __feholdexcept (fenv_t *envp)
diff --git a/sysdeps/i386/fpu/fesetenv.c b/sysdeps/i386/fpu/fesetenv.c
index 06d78484e9..66d7002edd 100644
--- a/sysdeps/i386/fpu/fesetenv.c
+++ b/sysdeps/i386/fpu/fesetenv.c
@@ -21,7 +21,6 @@
 #include <assert.h>
 #include <unistd.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 
 /* All exceptions, including the x86-specific "denormal operand"
diff --git a/sysdeps/i386/fpu/fesetmode.c b/sysdeps/i386/fpu/fesetmode.c
index 33e85ecfa6..eab0a5d683 100644
--- a/sysdeps/i386/fpu/fesetmode.c
+++ b/sysdeps/i386/fpu/fesetmode.c
@@ -20,7 +20,6 @@
 #include <fpu_control.h>
 #include <unistd.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 /* All exceptions, including the x86-specific "denormal operand"
    exception.  */
diff --git a/sysdeps/i386/fpu/fesetround.c b/sysdeps/i386/fpu/fesetround.c
index ef6fc3af1b..ea1f9096b5 100644
--- a/sysdeps/i386/fpu/fesetround.c
+++ b/sysdeps/i386/fpu/fesetround.c
@@ -19,7 +19,6 @@
 #include <fenv.h>
 #include <unistd.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 int
 __fesetround (int round)
diff --git a/sysdeps/i386/fpu/feupdateenv.c b/sysdeps/i386/fpu/feupdateenv.c
index 38ae5f4993..89b000953a 100644
--- a/sysdeps/i386/fpu/feupdateenv.c
+++ b/sysdeps/i386/fpu/feupdateenv.c
@@ -18,7 +18,6 @@
 
 #include <fenv.h>
 #include <unistd.h>
-#include <dl-procinfo.h>
 #include <ldsodefs.h>
 
 int
diff --git a/sysdeps/i386/fpu/fgetexcptflg.c b/sysdeps/i386/fpu/fgetexcptflg.c
index f4c7765beb..be181af162 100644
--- a/sysdeps/i386/fpu/fgetexcptflg.c
+++ b/sysdeps/i386/fpu/fgetexcptflg.c
@@ -19,7 +19,6 @@
 #include <fenv.h>
 #include <unistd.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 
 int
diff --git a/sysdeps/i386/fpu/ftestexcept.c b/sysdeps/i386/fpu/ftestexcept.c
index 25cb027200..2d41ba22ac 100644
--- a/sysdeps/i386/fpu/ftestexcept.c
+++ b/sysdeps/i386/fpu/ftestexcept.c
@@ -18,7 +18,6 @@
 
 #include <fenv.h>
 #include <unistd.h>
-#include <dl-procinfo.h>
 #include <ldsodefs.h>
 
 int
diff --git a/sysdeps/i386/setfpucw.c b/sysdeps/i386/setfpucw.c
index df8fffc6f2..1edfd5be0a 100644
--- a/sysdeps/i386/setfpucw.c
+++ b/sysdeps/i386/setfpucw.c
@@ -21,7 +21,6 @@
 #include <fenv.h>
 #include <unistd.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 void
 __setfpucw (fpu_control_t set)
diff --git a/sysdeps/mach/hurd/dl-sysdep.c b/sysdeps/mach/hurd/dl-sysdep.c
index 173499c4c1..e629492583 100644
--- a/sysdeps/mach/hurd/dl-sysdep.c
+++ b/sysdeps/mach/hurd/dl-sysdep.c
@@ -43,7 +43,6 @@
 
 #include <entry.h>
 #include <dl-machine.h>
-#include <dl-procinfo.h>
 
 #include <dl-tunables.h>
 #include <not-errno.h>
diff --git a/sysdeps/powerpc/fpu/math_private.h b/sysdeps/powerpc/fpu/math_private.h
index 7065d276c0..a87ed62c42 100644
--- a/sysdeps/powerpc/fpu/math_private.h
+++ b/sysdeps/powerpc/fpu/math_private.h
@@ -21,7 +21,6 @@
 
 #include <sysdep.h>
 #include <ldsodefs.h>
-#include <dl-procinfo.h>
 
 #include_next <math_private.h>
 
diff --git a/sysdeps/powerpc/hwcapinfo.c b/sysdeps/powerpc/hwcapinfo.c
index ca9277bb1e..72e65ac7a0 100644
--- a/sysdeps/powerpc/hwcapinfo.c
+++ b/sysdeps/powerpc/hwcapinfo.c
@@ -18,7 +18,6 @@
 
 #include <unistd.h>
 #include <shlib-compat.h>
-#include <dl-procinfo.h>
 #include <cpu-features.c>
 
 tcbhead_t __tcb __attribute__ ((visibility ("hidden")));
diff --git a/sysdeps/unix/sysv/linux/dl-sysdep.c b/sysdeps/unix/sysv/linux/dl-sysdep.c
index b746ac2644..544902e6d2 100644
--- a/sysdeps/unix/sysv/linux/dl-sysdep.c
+++ b/sysdeps/unix/sysv/linux/dl-sysdep.c
@@ -21,7 +21,6 @@
 #include <dl-auxv.h>
 #include <dl-osinfo.h>
 #include <dl-parse_auxv.h>
-#include <dl-procinfo.h>
 #include <dl-tunables.h>
 #include <elf.h>
 #include <errno.h>
@@ -222,10 +221,6 @@ _dl_show_auxv (void)
       assert (AT_NULL == 0);
       assert (AT_IGNORE == 1);
 
-      /* Some entries are handled in a special way per platform.  */
-      if (_dl_procinfo (av->a_type, av->a_un.a_val) == 0)
-	continue;
-
       if (idx < sizeof (auxvars) / sizeof (auxvars[0])
 	  && auxvars[idx].form != unknown)
 	{
diff --git a/sysdeps/unix/sysv/linux/powerpc/elision-conf.c b/sysdeps/unix/sysv/linux/powerpc/elision-conf.c
index fe98c6ba71..451897bd3d 100644
--- a/sysdeps/unix/sysv/linux/powerpc/elision-conf.c
+++ b/sysdeps/unix/sysv/linux/powerpc/elision-conf.c
@@ -20,7 +20,6 @@
 #include <pthreadP.h>
 #include <elision-conf.h>
 #include <unistd.h>
-#include <dl-procinfo.h>
 #include <ldsodefs.h>
 
 #define TUNABLE_NAMESPACE elision
diff --git a/sysdeps/x86/dl-hwcap.h b/sysdeps/x86/dl-hwcap.h
index 2384897e60..d48240843e 100644
--- a/sysdeps/x86/dl-hwcap.h
+++ b/sysdeps/x86/dl-hwcap.h
@@ -25,7 +25,4 @@ enum
   HWCAP_X86_AVX512_1		= 1 << 2
 };
 
-/* We cannot provide a general printing function.  */
-#define _dl_procinfo(type, word) -1
-
 #endif /* dl-hwcap.h */